declare module "electron-builder-squirrel-windows/out/squirrelPack" {
  import { Arch } from "electron-builder-util"
  import { WinPackager } from "electron-builder/out/winPackager"

  export function convertVersion(version: string): string

  export interface SquirrelOptions {
    vendorPath: string
    remoteReleases?: string
    remoteToken?: string
    loadingGif?: string
    productName: string
    appId?: string
    name: string
    packageCompressionLevel?: number
    version: string
    msi?: any
    description?: string
    iconUrl?: string
    authors?: string
    extraMetadataSpecs?: string
    copyright?: string
  }

  export interface OutFileNames {
    setupFile: string
    packageFile: string
  }

  export function buildInstaller(options: SquirrelOptions, outputDirectory: string, outFileNames: OutFileNames, packager: WinPackager, appOutDir: string, outDir: string, arch: Arch): Promise<void>
}

declare module "electron-builder-squirrel-windows" {
  import { Arch, Target } from "electron-builder"
  import { SquirrelWindowsOptions } from "electron-builder/out/options/winOptions"
  import { WinPackager } from "electron-builder/out/winPackager"
  import { SquirrelOptions } from "electron-builder-squirrel-windows/out/squirrelPack"

  export default class SquirrelWindowsTarget extends Target {
    private readonly packager
    readonly outDir: string
    readonly options: SquirrelWindowsOptions
    constructor(packager: WinPackager, outDir: string)
    build(appOutDir: string, arch: Arch): Promise<void>
    private readonly appName
    computeEffectiveDistOptions(): Promise<SquirrelOptions>
  }
}

